#!/bin/bash
#
# Workload Automation v2 for LAVA
#
# Copyright (C) 2014, Linaro Limited.
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
#
# Author: Milosz Wasilewski <milosz.wasilewski@linaro.org>
#

set -e
echo "Preparing device for mode: $1"

if [ $1 == 'mp' ]
then
    # disable IKS
    IPADDR=`cat IPADDR`
    echo "Disable IKS for $IPADDR"
    adb connect $IPADDR:5555
    adb devices
    echo "Waiting for device"
    adb wait-for-device
    echo "adb -s $IPADDR:5555 shell \"echo 0 > /sys/kernel/bL_switcher/active\""
    adb -s $IPADDR:5555 shell "echo 0 > /sys/kernel/bL_switcher/active"
    adb -s $IPADDR:5555 shell "cat /sys/kernel/bL_switcher/active"
fi

if [ $1 == 'iks' ]
then
    # enable IKS
    IPADDR=`cat IPADDR`
    echo "Enable IKS for $IPADDR"
    adb connect $IPADDR:5555
    adb devices
    echo "Waiting for device"
    adb wait-for-device
    echo "adb -s $IPADDR:5555 shell \"echo 1 > /sys/kernel/bL_switcher/active\""
    adb -s $IPADDR:5555 shell "echo 1 > /sys/kernel/bL_switcher/active"
    adb -s $IPADDR:5555 shell "cat /sys/kernel/bL_switcher/active"
fi

if [ $1 == 'a7only' ]
then
    # disable IKS
    IPADDR=`cat IPADDR`
    echo "Disable IKS for $IPADDR"
    adb connect $IPADDR:5555
    adb devices
    echo "Waiting for device"
    adb wait-for-device
    echo "adb -s $IPADDR:5555 shell \"echo 0 > /sys/kernel/bL_switcher/active\""
    adb -s $IPADDR:5555 shell "echo 0 > /sys/kernel/bL_switcher/active"
    adb -s $IPADDR:5555 shell "cat /sys/kernel/bL_switcher/active"
    echo "Disable A15 cluster"
    adb -s $IPADDR:5555 shell "echo 0 > /sys/devices/system/cpu/cpu3/online"
    adb -s $IPADDR:5555 shell "echo 0 > /sys/devices/system/cpu/cpu4/online"
fi

if [ $1 == 'a15only' ]
then
    # disable IKS
    IPADDR=`cat IPADDR`
    echo "Disable IKS for $IPADDR"
    adb connect $IPADDR:5555
    adb devices
    echo "Waiting for device"
    adb wait-for-device
    echo "adb -s $IPADDR:5555 shell \"echo 0 > /sys/kernel/bL_switcher/active\""
    adb -s $IPADDR:5555 shell "echo 0 > /sys/kernel/bL_switcher/active"
    adb -s $IPADDR:5555 shell "cat /sys/kernel/bL_switcher/active"
    echo "Disable A7 cluster"
    adb -s $IPADDR:5555 shell "echo 0 > /sys/devices/system/cpu/cpu0/online"
    adb -s $IPADDR:5555 shell "echo 0 > /sys/devices/system/cpu/cpu1/online"
    adb -s $IPADDR:5555 shell "echo 0 > /sys/devices/system/cpu/cpu2/online"
fi

exit 0
